/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.65
        Device            :  PIC16F18325
        Driver Version    :  2.00
*/

/*
    (c) 2016 Microchip Technology Inc. and its subsidiaries. You may use this
    software and any derivatives exclusively with Microchip products.

    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY IMPLIED
    WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS FOR A
    PARTICULAR PURPOSE, OR ITS INTERACTION WITH MICROCHIP PRODUCTS, COMBINATION
    WITH ANY OTHER PRODUCTS, OR USE IN ANY APPLICATION.

    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE,
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP HAS
    BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO THE
    FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS IN
    ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT OF FEES, IF ANY,
    THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS SOFTWARE.

    MICROCHIP PROVIDES THIS SOFTWARE CONDITIONALLY UPON YOUR ACCEPTANCE OF THESE
    TERMS.
*/

#include "mcc_generated_files/mcc.h"

/* O[oϐ` */
volatile unsigned char State, MainState, Logic, RptFlag, Flag;
volatile unsigned char BitFlag, BitCount, DirFlag;
unsigned int MakerCode, DataCode, temp;
unsigned char Interval, Ptn, Dir, Set;
int Index, block, i;
unsigned char *ptr;
unsigned char data[8][18] = {
    {0xFF,0x00,0x00,0x00,0xFF,0x00,0x00,0x00,0xFF,0x55,0x55,0x00,0x00,0x55,0x55,0x55,0x00,0x55},
    {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},
    {0x80,0x00,0x00,0x00,0x80,0x00,0x00,0x00,0x80,0x80,0x00,0x00,0x00,0x80,0x00,0x00,0x00,0x80},
    {0x80,0x00,0x00,0x80,0x00,0x00,0x00,0x80,0x80,0x00,0x00,0x00,0x80,0x00,0x00,0x00,0x80,0x00},
    {0x40,0x00,0x00,0x10,0x00,0x00,0x00,0x80,0x80,0x00,0x00,0x00,0x03,0x00,0x40,0x00,0x80,0x00},
    {0x80,0x00,0x40,0x00,0x10,0x00,0x00,0x00,0x40,0x40,0x00,0x40,0x00,0x03,0x00,0x00,0x00,0x80},
    {0xFF,0x00,0x00,0x00,0xFF,0x00,0x00,0x00,0xFF,0xFF,0x00,0x00,0x00,0xFF,0x00,0x00,0x00,0xFF},
    {0x00,0xFF,0x00,0x00,0xFF,0x00,0x00,0x00,0xFF,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF}};
/* ֐vg^Cv */
void Process(unsigned int data);


/*
                         Main application
 */
void main(void)
{
    // initialize the device
    SYSTEM_Initialize();

    // When using interrupts, you need to set the Global and Peripheral Interrupt Enable bits
    // Use the following macros to:

    // Enable the Global Interrupts
    INTERRUPT_GlobalInterruptEnable();

    // Enable the Peripheral Interrupts
    INTERRUPT_PeripheralInterruptEnable();

    // Disable the Global Interrupts
    //INTERRUPT_GlobalInterruptDisable();

    // Disable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptDisable();
    
    /* ݒ荀*/
    Ptn = 0;  
    Interval = 10;
    Dir = 1; 
    /* ϐ*/
    State = 0;
    MainState = 0;
    ptr = &data[Ptn][0];
    block = 0; 
    while (1)
    {
        // Add your application code    
        /**** LED1oCgo͏ ***/
        if(Flag == 1){                              // ]JntOȈꍇ
             if(S1_GetValue() == 0)                 // XCb`Ȉꍇ
                SPI1_Exchange8bit(0);               // S
            else {                                  // XCb`It̏ꍇ
                SPI1_Exchange8bit(*ptr++);          // p^[f[^o
                if(ptr >= &data[Ptn][0] + 18)       // p^Ȉꍇ
                    ptr = &data[Ptn][0];            // ŏɖ߂
            }      
            /* SLEDo͊̏ꍇ̏ */
            Index++;                                // o͉񐔃JE^Abv
            if(Index > 150){                        // SLEDo͏Ȉꍇ
                Index = 0;                          // JE^Zbg
                Flag = 0;                           // 1IŊJntOIt
                block++;                            // LEDp^[ړp
                if(block > 5)                       // p^[эŌ̏ꍇ
                    block = 0;                      // ŏɖ߂
                if(Dir == 1)                        // ʑŃ|C^XV
                    ptr = &data[Ptn][block * 3];    // t]̂Ƃ֒
                else                                // ]̏ꍇ
                    ptr = &data[Ptn][15 -(block * 3)];  // Oɒ
                if(DirFlag){
                    DirFlag = 0;
                    if(Dir == 1)                    // ]]
                        Dir = 0;
                    else
                        Dir = 1;                
                }
            }
        }
        /*** ԊOȐ ****/
        switch(MainState){
            case 1:                             // CXe[g1̏ꍇ
                if(RptFlag == 1){               // s[gtOȈꍇ
//                    Process(DataCode);        // Õf[^ŏs
                    MainState = 0;              // Xe[gɖ߂
                }
                else{                           // ʏt[̏ꍇ
                    MainState = 2;              // ̃Xe[g
                    BitCount = 0;               // rbgJE^Zbg
                    MakerCode = 0;
                }
                break;
            case 2:                             // [JR[hM            
                if(BitFlag == 1){               // rbgMĂꍇ
                    BitFlag = 0;                // ]tOvNA
                    MakerCode = MakerCode << 1; // [JR[hVtgĊi[
                    MakerCode += (unsigned int)Logic;
                    BitCount++;                 // rbgJE^XV
                    if(BitCount >= 16){         // 16rbgM̏ꍇ                                          
                        if(MakerCode == 0x08F7){// ƍvꍇ                        
                            MainState = 3;      // ̃Xe[g                           
                        }
                        else{                   // ƍsv̏ꍇ                          
                            MainState = 0;      // G[AԂ
                            State = 0;
                        }
                        BitCount = 0;
                        DataCode = 0;
                    } 
                }
                break;
            case 3:                             // f[^R[hM                 
                if(BitFlag == 1){               // rbgMĂꍇ                     
                    BitFlag = 0;                // tONA                
                    DataCode = DataCode << 1;   // [JR[hVtgĊi[
                    DataCode += (unsigned int)Logic;
                    BitCount++;                 // rbgJE^XV
                    if(BitCount >= 16){         // 16rbgM̏ꍇ                   
                        temp = ~DataCode;       // ]2Aƍ
                        temp = temp & DataCode;
                        if(temp == 0){          // ƍvꍇ                             
                            Process(DataCode);  // Mf[^               
                            MainState = 0;      // Xe[gŏɖ߂ 
                            State = 0;
                        }
                        else{                   // ƍsv̏ꍇ      
                            MainState = 0;      // G[AԂ
                            State = 0;
                        }
                    } 
                }
                break;
            default :
                break;
        }        
    }
}
/**********************************
 *  Mf[^֐
 *  Mf[^ɏ]Đݒ萧
 **********************************/
void Process(unsigned int data){
    LED_Toggle();
    switch(data){
        case 0x1BE4:                // Power
            break;
        case 0x1FE0:                // A
            Set = 0;
            Ptn++;                  // p^[ύX
            if(Ptn > 7)
                Ptn = 0;
            break;
        case 0x1EE1:                // B
            Set = 1;                // xύX
            break;
        case 0x1AE5:                // C
            DirFlag = 1;
            Set = 2;
            break;
        case 0x05FA:                // 
            switch(Set){
                case 0:break;
                case 1:
                    if(Interval > 2)// xAbv
                        Interval--;
                    break;
            }
            break;
        case 0x00FF:                // 
            switch(Set){
                case 0:break;
                case 1:
                    if(Interval < 100)// x_E
                        Interval++;
            }
            break;
        case 0x08F7:            // 
        case 0x01FE:            // 
        case 0x04FB:            // white
        case 0x8D72:            // 
        case 0x8877:            // 
        case 0x847B:            // E
        case 0x817E:            // E          
        default:
            break;     
    }
}

/**
 End of File
*/